<template>
    <Modal
        v-if="countries"
        :show="show"
        title="Send SMS To"
        hide-footer
        hide-header
        content-class="modal_countries"
        size="md"
        centered
        @close="$emit('close')"
    >
        <InputWithIcon
            class="full-width modal_countries__input"
            left-icon="/images/search.svg"
            @input="search"
        />
        <div class="wrapper">
            <Countries
                :props-countries="items"
                active
                accordion
                @input="updValue"
            />
        </div>
        <div class="footer"> 
            <b-button
                variant="primary"
                :class="{'loading-xs': loading}"
                class="btn-blue btn_save"
                @click="save"
            >
                <template v-if="!loading">
                    Done
                </template>
            </b-button>
        </div>
    </Modal>
</template>

<script>
import Modal from "@/components/elements/Modal.vue";
import Countries from "@/components/elements/Countries";
import InputWithIcon from "@/components/elements/InputWithIcon";
import api from '@/services/settings.service.js'

export default {
  components: {
    Modal,
    Countries,
    InputWithIcon,
  },
  props: {
    show: {
      type: Boolean,
      default: false,
    },
    countries: {
      type: Array,
    },
  },
  data() {
      return {
          items: null,
          loading: false,
      }
  },
  created() {
      this.items = this.countries
  },
  methods: {
      search(e) {
        this.items = this.countries
        if(e) {
            const searchValue = e.toLowerCase()
            const countries = this.items.filter(el => el.country.split(' ').join('').toLowerCase().indexOf(searchValue) > -1)
            this.items = countries
        }
      },
      updValue(items) {
        this.items = items
      },
      async save() {
        this.loading = true
        await api.updateCountries({countries: this.countries})
        this.loading = false
        this.$notify({
          type: 'success',
          title: 'Changes saved'
        })
        this.$emit('close')
      }
  }
};
</script>

<style lang="scss" scoped>
.wrapper {
  width: calc(100% + 10px);
    overflow-y: scroll;
    height: 282px;
    padding-right: 20px;
    padding-top: 24px;

}

.footer {
  border-top: 1px solid #eeeff0;
  padding-top: 10px;
  display: flex;
  justify-content: flex-end;
  width: 100%;
}
.btn {
  width: 70px;
  height: 35px;
}
</style>

<style lang="scss">
.modal_countries {
  width: 420px;
  .modal-popup-body {
    padding: 11px 16px 10px 16px;  
  }
  .popup-header-text {
        font-weight: 400;
        font-size: 24px;
        line-height: 28px;
    }
    .input_blue {
        max-height: 40px !important;
    }
}
</style>